import numpy as np

# pocet segmentov gule, valca, ihlana
segs: int = 18


class myObjects:
    def __init__(self):
        self.v_a = []  # pole vrcholov
        self.c_a = []  # pole farieb
        self.n_a = []  # pole normal
        self.t_a = []  # pole texturovacich suradnic

        self.vertices_num = 0  # celkovy pocet vrcholov

    def fill_arrays(self):
        e = 108  # pocet udajov patriacich kocke

        # kocka ------------------------------------------------------------------
        # vrcholy
        tmp = [-4.0, 0.0, 4.0, -2.0, 0.0, 4.0, -2.0, 2.0, 4.0,
               -4.0, 0.0, 4.0, -2.0, 2.0, 4.0, -4.0, 2.0, 4.0,
               -2.0, 0.0, 4.0, -2.0, 0.0, 2.0, -2.0, 2.0, 2.0,
               -2.0, 0.0, 4.0, -2.0, 2.0, 2.0, -2.0, 2.0, 4.0,
               -2.0, 0.0, 2.0, -4.0, 0.0, 2.0, -4.0, 2.0, 2.0,
               -2.0, 0.0, 2.0, -4.0, 2.0, 2.0, -2.0, 2.0, 2.0,
               -4.0, 0.0, 2.0, -4.0, 0.0, 4.0, -4.0, 2.0, 4.0,
               -4.0, 0.0, 2.0, -4.0, 2.0, 4.0, -4.0, 2.0, 2.0,
               -4.0, 2.0, 4.0, -2.0, 2.0, 4.0, -2.0, 2.0, 2.0,
               -4.0, 2.0, 4.0, -2.0, 2.0, 2.0, -4.0, 2.0, 2.0,
               -4.0, 0.0, 2.0, -2.0, 0.0, 2.0, -2.0, 0.0, 4.0,
               -4.0, 0.0, 2.0, -2.0, 0.0, 4.0, -4.0, 0.0, 4.0]
        for i in range(e):
            self.v_a.append(tmp[i])
        # farby
        for i in range(int(e/3)):
            self.c_a.append(0.5); self.c_a.append(0.0); self.c_a.append(0.0)
        # normaly
        tmp = [ 0.0,  0.0,  1.0,  0.0,  0.0,  1.0,  0.0,  0.0,  1.0,
                0.0,  0.0,  1.0,  0.0,  0.0,  1.0,  0.0,  0.0,  1.0,
                1.0,  0.0,  0.0,  1.0,  0.0,  0.0,  1.0,  0.0,  0.0,
                1.0,  0.0,  0.0,  1.0,  0.0,  0.0,  1.0,  0.0,  0.0,
                0.0,  0.0, -1.0,  0.0,  0.0, -1.0,  0.0,  0.0, -1.0,
                0.0,  0.0, -1.0,  0.0,  0.0, -1.0,  0.0,  0.0, -1.0,
               -1.0,  0.0,  0.0, -1.0,  0.0,  0.0, -1.0,  0.0,  0.0,
               -1.0,  0.0,  0.0, -1.0,  0.0,  0.0, -1.0,  0.0,  0.0,
                0.0,  1.0,  0.0,  0.0,  1.0,  0.0,  0.0,  1.0,  0.0,
                0.0,  1.0,  0.0,  0.0,  1.0,  0.0,  0.0,  1.0,  0.0,
                0.0, -1.0,  0.0,  0.0, -1.0,  0.0,  0.0, -1.0,  0.0,
                0.0, -1.0,  0.0,  0.0, -1.0,  0.0,  0.0, -1.0,  0.0]
        for i in range(e):
            self.n_a.append(tmp[i])
        # texturovacie suradnice
        tmp = [0.0, 0.0, 1.0, 0.0, 1.0, 1.0,
               0.0, 0.0, 1.0, 1.0, 0.0, 1.0,
               0.0, 0.0, 1.0, 0.0, 1.0, 1.0,
               0.0, 0.0, 1.0, 1.0, 0.0, 1.0,
               0.0, 0.0, 1.0, 0.0, 1.0, 1.0,
               0.0, 0.0, 1.0, 1.0, 0.0, 1.0,
               0.0, 0.0, 1.0, 0.0, 1.0, 1.0,
               0.0, 0.0, 1.0, 1.0, 0.0, 1.0,
               0.0, 0.0, 1.0, 0.0, 1.0, 1.0,
               0.0, 0.0, 1.0, 1.0, 0.0, 1.0,
               0.0, 0.0, 1.0, 0.0, 1.0, 1.0,
               0.0, 0.0, 1.0, 1.0, 0.0, 1.0]
        for i in range(int(e/3*2)):
            self.t_a.append(tmp[i])

        self.vertices_num = e / 3  # celkovy pocet vrcholov

        # gula -------------------------------------------------------------------
        f = 0  # pomocna premenna
        for j in range(180):
            if j % segs:
                continue
            for i in range(360):
                if i % segs:
                    continue

                alfa0 = np.deg2rad(i); beta0 = np.deg2rad(j)
                alfa1 = np.deg2rad(i + segs); beta1 = np.deg2rad(j + segs)

                x0 = 3.0 + np.cos(alfa0) * np.sin(beta0); x1 = 3.0 + np.cos(alfa1) * np.sin(beta0)
                x2 = 3.0 + np.cos(alfa1) * np.sin(beta1); x3 = 3.0 + np.cos(alfa0) * np.sin(beta1)
                y0 = 1.0 + np.cos(beta0); y1 = 1.0 + np.cos(beta1)
                z0 = 3.0 + np.sin(alfa0) * np.sin(beta0); z1 = 3.0 + np.sin(alfa1) * np.sin(beta0)
                z2 = 3.0 + np.sin(alfa1) * np.sin(beta1); z3 = 3.0 + np.sin(alfa0) * np.sin(beta1)

                self.v_a.append(x0); self.v_a.append(y0); self.v_a.append(z0)  # 1. vrchol
                self.v_a.append(x1); self.v_a.append(y0); self.v_a.append(z1)  # 2. vrchol
                self.v_a.append(x2); self.v_a.append(y1); self.v_a.append(z2)  # 3. vrchol
                self.c_a.append(0.0); self.c_a.append(0.5); self.c_a.append(0.0)  # 1. vrchol
                self.c_a.append(0.0); self.c_a.append(0.5); self.c_a.append(0.0)  # 2. vrchol
                self.c_a.append(0.0); self.c_a.append(0.5); self.c_a.append(0.0)  # 3. vrchol
                self.t_a.append(float(i) / 90.0); self.t_a.append(float(j) / 90.0)  # 1. vrchol
                self.t_a.append(float(i + segs) / 90.0); self.t_a.append(float(j) / 90.0)  # 2. vrchol
                self.t_a.append(float(i + segs) / 90.0); self.t_a.append(float(j + segs) / 90.0)  # 3. vrchol

                self.v_a.append(x0); self.v_a.append(y0); self.v_a.append(z0)  # 1. vrchol
                self.v_a.append(x2); self.v_a.append(y1); self.v_a.append(z2)  # 2. vrchol
                self.v_a.append(x3); self.v_a.append(y1); self.v_a.append(z3)  # 3. vrchol
                self.c_a.append(0.0); self.c_a.append(0.5); self.c_a.append(0.0)  # 1. vrchol
                self.c_a.append(0.0); self.c_a.append(0.5); self.c_a.append(0.0)  # 2. vrchol
                self.c_a.append(0.0); self.c_a.append(0.5); self.c_a.append(0.0)  # 3. vrchol
                self.t_a.append(float(i) / 90.0); self.t_a.append(float(j) / 90.0)  # 1. vrchol
                self.t_a.append(float(i + segs) / 90.0); self.t_a.append(float(j + segs) / 90.0)  # 2. vrchol
                self.t_a.append(float(i) / 90.0); self.t_a.append(float(j + segs) / 90.0)  # 3. vrchol

                f += 6  # pribudlo 6 vrcholov

        self.vertices_num += f  # celkovy pocet vrcholov

        # valec ------------------------------------------------------------------
        f = 0  # pomocna premenna
        for i in range(360):
            if i % segs:
                continue

            alfa0 = np.deg2rad(float(i)); alfa1 = np.deg2rad(float(i + segs))

            x0 = 3.0 + np.cos(alfa0); x1 = 3.0 + np.cos(alfa1)
            y0 = 0.0; y1 = 2.0
            z0 = -3.0 - np.sin(alfa0); z1 = -3.0 - np.sin(alfa1)

            self.v_a.append(x0); self.v_a.append(y0); self.v_a.append(z0)  # 1. vrchol
            self.v_a.append(x1); self.v_a.append(y0); self.v_a.append(z1)  # 2. vrchol
            self.v_a.append(x1); self.v_a.append(y1); self.v_a.append(z1)  # 3. vrchol
            self.c_a.append(0.0); self.c_a.append(0.0); self.c_a.append(0.5)  # 1. vrchol
            self.c_a.append(0.0); self.c_a.append(0.0); self.c_a.append(0.5)  # 2. vrchol
            self.c_a.append(0.0); self.c_a.append(0.0); self.c_a.append(0.5)  # 3. vrchol
            self.t_a.append(float(i) / 90.0); self.t_a.append(0.0)  # 1. vrchol
            self.t_a.append(float(i + segs) / 90.0); self.t_a.append(0.0)  # 2. vrchol
            self.t_a.append(float(i + segs) / 90.0); self.t_a.append(1.0)  # 3. vrchol

            self.v_a.append(x0); self.v_a.append(y0); self.v_a.append(z0)  # 1. vrchol
            self.v_a.append(x1); self.v_a.append(y1); self.v_a.append(z1)  # 2. vrchol
            self.v_a.append(x0); self.v_a.append(y1); self.v_a.append(z0)  # 3. vrchol
            self.c_a.append(0.0); self.c_a.append(0.0); self.c_a.append(0.5)  # 1. vrchol
            self.c_a.append(0.0); self.c_a.append(0.0); self.c_a.append(0.5)  # 2. vrchol
            self.c_a.append(0.0); self.c_a.append(0.0); self.c_a.append(0.5)  # 3. vrchol
            self.t_a.append(float(i) / 90.0); self.t_a.append(0.0)  # 1. vrchol
            self.t_a.append(float(i + segs) / 90.0); self.t_a.append(1.0)  # 2. vrchol
            self.t_a.append(float(i) / 90.0); self.t_a.append(1.0)  # 3. vrchol

            self.v_a.append(x0); self.v_a.append(2.0); self.v_a.append(z0)  # 1. vrchol
            self.v_a.append(x1); self.v_a.append(2.0); self.v_a.append(z1)  # 2. vrchol
            self.v_a.append(3.0); self.v_a.append(2.0); self.v_a.append(-3.0)  # 3. vrchol
            self.c_a.append(0.0); self.c_a.append(0.0); self.c_a.append(0.5)  # 1. vrchol
            self.c_a.append(0.0); self.c_a.append(0.0); self.c_a.append(0.5)  # 2. vrchol
            self.c_a.append(0.0); self.c_a.append(0.0); self.c_a.append(0.5)  # 3. vrchol
            self.t_a.append(0.0); self.t_a.append(0.0)  # 1. vrchol
            self.t_a.append(0.1); self.t_a.append(0.0)  # 2. vrchol
            self.t_a.append(0.1); self.t_a.append(1.0)  # 3. vrchol

            self.v_a.append(x1); self.v_a.append(0.0); self.v_a.append(z1)  # 1. vrchol
            self.v_a.append(x0); self.v_a.append(0.0); self.v_a.append(z0)  # 2. vrchol
            self.v_a.append(3.0); self.v_a.append(0.0); self.v_a.append(-3.0)  # 3. vrchol
            self.c_a.append(0.0); self.c_a.append(0.0); self.c_a.append(0.5)  # 1. vrchol
            self.c_a.append(0.0); self.c_a.append(0.0); self.c_a.append(0.5)  # 2. vrchol
            self.c_a.append(0.0); self.c_a.append(0.0); self.c_a.append(0.5)  # 3. vrchol
            self.t_a.append(0.0); self.t_a.append(0.0)  # 1. vrchol
            self.t_a.append(0.1); self.t_a.append(0.0)  # 2. vrchol
            self.t_a.append(0.1); self.t_a.append(1.0)  # 3. vrchol

            f += 12  # pribudlo 12 vrcholov

        self.vertices_num += f  # celkovy pocet vrcholov

        # ihlan ------------------------------------------------------------------
        f = 0  # pomocna premenna
        for i in range(360):
            if i % segs:
                continue

            alfa0 = np.deg2rad(float(i)); alfa1 = np.deg2rad(float(i + segs))

            x0 = -3.0 + np.cos(alfa0); x1 = -3.0 + np.cos(alfa1)
            y0 = 0.0; y1 = 2.0
            z0 = -3.0 - np.sin(alfa0); z1 = -3.0 - np.sin(alfa1)

            self.v_a.append(x0); self.v_a.append(y0); self.v_a.append(z0)  # 1. vrchol
            self.v_a.append(x1); self.v_a.append(y0); self.v_a.append(z1)  # 2. vrchol
            self.v_a.append(-3.0); self.v_a.append(y1); self.v_a.append(-3.0)  # 3. vrchol
            self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.0)  # 1. vrchol
            self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.0)  # 2. vrchol
            self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.0)  # 3. vrchol
            self.t_a.append(0.0); self.t_a.append(0.0)  # 1. vrchol
            self.t_a.append(0.1); self.t_a.append(0.0)  # 2. vrchol
            self.t_a.append(0.1); self.t_a.append(1.0)  # 3. vrchol

            self.v_a.append(x1); self.v_a.append(0.0); self.v_a.append(z1)  # 1. vrchol
            self.v_a.append(x0); self.v_a.append(0.0); self.v_a.append(z0)  # 2. vrchol
            self.v_a.append(-3.0); self.v_a.append(0.0); self.v_a.append(-3.0)  # 3. vrchol
            self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.0)  # 1. vrchol
            self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.0)  # 2. vrchol
            self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.0)  # 3. vrchol
            self.t_a.append(0.0); self.t_a.append(0.0)  # 1. vrchol
            self.t_a.append(0.1); self.t_a.append(0.0)  # 2. vrchol
            self.t_a.append(0.1); self.t_a.append(1.0)  # 3. vrchol

            f += 6  # pribudlo 6 vrcholov

        self.vertices_num += f  # celkovy pocet vrcholov

        # plochy -----------------------------------------------------------------
        self.v_a.append(-5.0); self.v_a.append(0.0); self.v_a.append(5.0)  # 1. vrchol
        self.v_a.append(5.0); self.v_a.append(0.0); self.v_a.append(5.0)  # 2. vrchol
        self.v_a.append(5.0); self.v_a.append(0.0); self.v_a.append(-5.0)  # 3. vrchol
        self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.5)  # 1. vrchol
        self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.5)  # 2. vrchol
        self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.5)  # 3. vrchol
        self.t_a.append(0.0); self.t_a.append(0.0)  # 1. vrchol
        self.t_a.append(1.0); self.t_a.append(0.0)  # 2. vrchol
        self.t_a.append(1.0); self.t_a.append(1.0)  # 3. vrchol

        self.v_a.append(-5.0); self.v_a.append(0.0); self.v_a.append(5.0)  # 1. vrchol
        self.v_a.append(5.0); self.v_a.append(0.0); self.v_a.append(-5.0)  # 2. vrchol
        self.v_a.append(-5.0); self.v_a.append(0.0); self.v_a.append(-5.0)  # 3. vrchol
        self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.5)  # 1. vrchol
        self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.5)  # 2. vrchol
        self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.5)  # 3. vrchol
        self.t_a.append(0.0); self.t_a.append(0.0)  # 1. vrchol
        self.t_a.append(1.0); self.t_a.append(1.0)  # 2. vrchol
        self.t_a.append(0.0); self.t_a.append(1.0)  # 3. vrchol

        self.v_a.append(-5.0); self.v_a.append(0.0); self.v_a.append(-5.0)  # 1. vrchol
        self.v_a.append(5.0); self.v_a.append(0.0); self.v_a.append(-5.0)  # 2. vrchol
        self.v_a.append(5.0); self.v_a.append(10.0); self.v_a.append(-5.0)  # 3. vrchol
        self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.5)  # 1. vrchol
        self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.5)  # 2. vrchol
        self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.5)  # 3. vrchol
        self.t_a.append(0.0); self.t_a.append(0.0)  # 1. vrchol
        self.t_a.append(1.0); self.t_a.append(0.0)  # 2. vrchol
        self.t_a.append(1.0); self.t_a.append(1.0)  # 3. vrchol

        self.v_a.append(-5.0); self.v_a.append(0.0); self.v_a.append(-5.0)  # 1. vrchol
        self.v_a.append(5.0); self.v_a.append(10.0); self.v_a.append(-5.0)  # 2. vrchol
        self.v_a.append(-5.0); self.v_a.append(10.0); self.v_a.append(-5.0)  # 3. vrchol
        self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.5)  # 1. vrchol
        self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.5)  # 2. vrchol
        self.c_a.append(0.5); self.c_a.append(0.5); self.c_a.append(0.5)  # 3. vrchol
        self.t_a.append(0.0); self.t_a.append(0.0)  # 1. vrchol
        self.t_a.append(1.0); self.t_a.append(1.0)  # 2. vrchol
        self.t_a.append(0.0); self.t_a.append(1.0)  # 3. vrchol

        f = 12  # pribudlo 12 vrcholov

        self.vertices_num += f  # celkovy pocet vrcholov

    # celkovy pocet vrcholov -----------------------------------------------------
    def get_vertices_num(self):
        return int(self.vertices_num)

    def get_vertices(self):
        return np.array(self.v_a, dtype=np.float32)

    def get_colors(self):
        return np.array(self.c_a, dtype=np.float32)

    def get_normals(self):
        return np.array(self.n_a, dtype=np.float32)

    def get_texcoords(self):
        return np.array(self.t_a, dtype=np.float32)
